% specify server and application name
s = 'http://byu.apmonitor.com';
a = 'jennings';

addpath('apm')
apm(s,a,'clear all');
apm_load(s,a,[a '.apm']);
csv_load(s,a,[a '.csv']);

apm_option(s,a,'nlc.nodes',2);
apm_option(s,a,'nlc.solver',3);
apm_option(s,a,'nlc.imode',6);
apm_option(s,a,'nlc.max_iter',500);
apm_option(s,a,'nlc.mv_type',1);

apm_info(s,a,'FV','tf');
apm_option(s,a,'tf.status',1);

apm_info(s,a,'MV','u');
apm_option(s,a,'u.status',1);
apm_option(s,a,'u.dcost',1e-6);

output = apm(s,a,'solve');
disp(output)
y = apm_sol(s,a);
z = y.x;

tf = z.tf(end);
disp(['Optimal Solution: ' num2str(tf)])

figure(1)
plot(z.time*tf,z.x1,'b--','LineWidth',2)
hold on
plot(z.time*tf,z.x2,'g:','LineWidth',2)
plot(z.time*tf,z.x3,'k-.','LineWidth',2)
plot(z.time*tf,z.u,'r.-','LineWidth',2)
legend('x1','x2','x3','u')
ylabel('Variables')
xlabel('Time')
axis tight
