# specify server and application name
s = 'http://byu.apmonitor.com'
a = 'jennings'

from apm import *
apm(s,a,'clear all')
apm_load(s,a,a+'.apm')
csv_load(s,a,a+'.csv')

apm_option(s,a,'nlc.nodes',2)
apm_option(s,a,'nlc.solver',3)
apm_option(s,a,'nlc.imode',6)
apm_option(s,a,'nlc.max_iter',500)
apm_option(s,a,'nlc.mv_type',1)

apm_info(s,a,'FV','tf')
apm_option(s,a,'tf.status',1)

apm_info(s,a,'MV','u')
apm_option(s,a,'u.status',1)
apm_option(s,a,'u.dcost',1e-6)

output = apm(s,a,'solve')
print (output)
y = apm_sol(s,a)

tf = y['tf'][-1]
print ('Optimal Solution: ' + str(tf))

import matplotlib.pyplot as plt
import numpy as np
ns = len(y['time'])
t = np.empty((ns))
for i in range(ns):
    t[i] = y['time'][i] * tf

plt.figure(1)
plt.plot(t,y['x1'],'b--',linewidth=2)
plt.plot(t,y['x2'],'g:',linewidth=2)
plt.plot(t,y['x3'],'k-.',linewidth=2)
plt.plot(t,y['u'],'r.-',linewidth=2)
plt.legend(['x1','x2','x3','u'])
plt.ylabel('Variables')
plt.xlabel('Time')
plt.show()
